// UnExpandTest.cpp
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <shlwapi.h>
#include <cstdio>
using namespace std;

int main(void)
{
    CHAR szPathA[MAX_PATH];
    WCHAR szPathW[MAX_PATH];
    DWORD ret;

    ret = PathUnExpandEnvStringsA("C:\\Program Files\\Test", szPathA, MAX_PATH);
    printf("PathUnExpandEnvStringsA: %d: %s\n", ret, szPathA);

    ret = PathUnExpandEnvStringsA("C:\\Windows\\Test.txt", szPathA, MAX_PATH);
    printf("PathUnExpandEnvStringsA: %d: %s\n", ret, szPathA);

    ret = PathUnExpandEnvStringsW(L"C:\\Program Files\\Test", szPathW, MAX_PATH);
    printf("PathUnExpandEnvStringsW: %d: %ls\n", ret, szPathW);

    ret = PathUnExpandEnvStringsW(L"C:\\Windows\\Test.txt", szPathW, MAX_PATH);
    printf("PathUnExpandEnvStringsW: %d: %ls\n", ret, szPathW);

    ret = ExpandEnvironmentStringsA("C:\\Program Files\\Test", szPathA, MAX_PATH);
    printf("ExpandEnvironmentStringsA: %d: %s\n", ret, szPathA);

    ret = ExpandEnvironmentStringsA("C:\\Windows\\Test.txt", szPathA, MAX_PATH);
    printf("ExpandEnvironmentStringsA: %d: %s\n", ret, szPathA);

    ret = ExpandEnvironmentStringsW(L"C:\\Program Files\\Test", szPathW, MAX_PATH);
    printf("ExpandEnvironmentStringsW: %d: %ls\n", ret, szPathW);

    ret = ExpandEnvironmentStringsW(L"C:\\Windows\\Test.txt", szPathW, MAX_PATH);
    printf("ExpandEnvironmentStringsW: %d: %ls\n", ret, szPathW);

    return 0;
}
